unit UnitFrmExpert;
{
  Pan Ying,Zero Studio,2002.2.15
  All Right Reserved.

Attention:
    This software is provided 'as-is', without any express or
  implied warranty. In no event will the author be held liable
  for any damages arising from the use of this software.
    The origin of this software must not be misrepresented,
  you must not claim that you wrote the original software.
    This attention may not be removed or altered from any source
  distribution.

Feedback:
  E-Mail:  panying@sina.com
  HomePage:http://myzeroworld.yeah.net
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Tabs, ComCtrls, StdCtrls, Buttons;

type
  TExpertForm = class(TForm)
    BottomPanel: TPanel;
    TabSet1: TTabSet;
    PageControl1: TPageControl;
    StartSheet: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    EditName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditParent: TEdit;
    Label3: TLabel;
    EditUnit: TEdit;
    SpeedButton1: TSpeedButton;
    SaveDialog1: TSaveDialog;
    Label4: TLabel;
    ComboBoxType: TComboBox;
    PropertySheet: TTabSheet;
    Label5: TLabel;
    EditIDString: TEdit;
    Label6: TLabel;
    EditExpertName: TEdit;
    Label7: TLabel;
    EditAuthor: TEdit;
    Label8: TLabel;
    ComboBoxPage: TComboBox;
    Label9: TLabel;
    EditMenu: TEdit;
    Label10: TLabel;
    EditComment: TEdit;
    PreviewSheet: TTabSheet;
    Memo1: TMemo;
    procedure PageControl1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BitBtn3Click(Sender: TObject);
    procedure PreviewSheetShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    SaveIndex:integer;
    function Preview:boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExpertForm: TExpertForm;

implementation

{$R *.DFM}

procedure TExpertForm.PageControl1Change(Sender: TObject);
begin
  BitBtn1.Enabled:=(PageControl1.ActivePageIndex>0)and(PageControl1.ActivePageIndex<PageControl1.PageCount-1);
  BitBtn2.Enabled:=PageControl1.ActivePageIndex<PageControl1.PageCount-2;
end;

procedure TExpertForm.FormShow(Sender: TObject);
begin
  PageControl1Change(Sender);

end;

procedure TExpertForm.BitBtn1Click(Sender: TObject);
begin
  PageControl1.ActivePageIndex:=PageControl1.ActivePageIndex-1;
  PageControl1Change(Sender);
end;

procedure TExpertForm.BitBtn2Click(Sender: TObject);
begin
  PageControl1.ActivePageIndex:=PageControl1.ActivePageIndex+1;
  PageControl1Change(Sender);
end;

procedure TExpertForm.SpeedButton1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
    EditUnit.Text:=SaveDialog1.FileName;
end;

procedure TExpertForm.FormCreate(Sender: TObject);
begin
  ComboBoxType.ItemIndex:=0;
end;

procedure TExpertForm.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if NewTab=0 then
    PageControl1.ActivePageIndex:=SaveIndex
  else
  begin
    SaveIndex:=PageControl1.ActivePageIndex;
    PageControl1.ActivePageIndex:=2;
  end;

  PageControl1Change(Sender);
end;

procedure TExpertForm.BitBtn3Click(Sender: TObject);
begin
  Close;
end;

function TExpertForm.Preview: boolean;
var
  theUnitName:string;
  UseString:string;
begin
  result:=false;

  if (EditName.Text='') or (EditParent.Text='') or (EditUnit.Text='') then
  begin
    ShowMessage('Class Name and Parent Class Name and Unit Name should not be empty!');
    exit;
  end;

  result:=true;

  Memo1.Clear;

  theUnitName:=ExtractFileName(EditUnit.Text);
  theUnitName:=copy(theUnitName,1,pos('.',theUnitName)-1);

  Memo1.Lines.Add('Unit '+theUnitName+';');

  Memo1.Lines.Add('{ Generated by Zero Wizard Expert,'+DateToStr(Date));
  Memo1.Lines.Add('  Visit http://myzeroworld.yeah.net for new Zero Wizard Expert version}');

  Memo1.Lines.Add('');
  Memo1.Lines.Add('interface');

  Memo1.Lines.Add('');
  Memo1.Lines.Add('uses');
  UseString:='ExptIntf,Windows';

  if ComboBoxType.Text<>'esAddIn' then
    UseString:=UseString+';'
  else
    UseString:=UseString+',ToolIntf;';


  //class declare
  Memo1.Lines.Add(#9+UseString);
  Memo1.Lines.Add('');

  Memo1.Lines.Add('type');
  Memo1.Lines.Add(#9+EditName.Text+'=class('+EditParent.Text+')');
  Memo1.Lines.Add(#9+'public');
  Memo1.Lines.Add(#9+#9+'function GetStyle:TExpertStyle;override;');
  Memo1.Lines.Add(#9+#9+'function GetName:string;override;');
  Memo1.Lines.Add(#9+#9+'function GetAuthor:string;override;');
  Memo1.Lines.Add(#9+#9+'function GetComment:string;override;');
  Memo1.Lines.Add(#9+#9+'function GetPage:string;override;');
  Memo1.Lines.Add(#9+#9+'function GetGlyph:HICON;override;');
  Memo1.Lines.Add(#9+#9+'function GetState:TExpertState;override;');
  Memo1.Lines.Add(#9+#9+'function GetIDString:string;override;');
  Memo1.Lines.Add(#9+#9+'function GetMenuText:string;override;');
  Memo1.Lines.Add(#9+#9+'procedure Execute;override;');

  if ComboBoxType.Text='esAddIn' then
  begin
    Memo1.Lines.Add(#9+#9+'constructor Create;override;');
    Memo1.Lines.Add(#9+#9+'destructor Destroy;override;');
  end;

  Memo1.Lines.Add(#9+'end');

  //registe procedure
  Memo1.Lines.Add('');
  Memo1.Lines.Add('procedure Register;');

  //implementation section
  Memo1.Lines.Add('implementation');
  Memo1.Lines.Add('');
  Memo1.Lines.Add('procedure Register;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'RegisterLibraryExpert(TZeroWizrdExpert.Create);');
  Memo1.Lines.Add('end;');

  //function implementation
  Memo1.Lines.Add('');
  Memo1.Lines.Add('{'+EditName.Text+'}');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('procedure '+EditName.Text+'.Execute;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'//your execute code here');
  Memo1.Lines.Add(#9);
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetAuthor: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+EditAuthor.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetComment: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+EditComment.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetIDString: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+EditIDString.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetMenuText: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+EditMenu.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetName: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+EditExpertName.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetPage: string;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='''+ComboBoxPage.Text+''';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetStyle: TExpertStyle;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:='+ComboBoxType.Text+';');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetGlyph: HICON;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:=0;');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('function '+EditName.Text+'.GetState: TExpertState;');
  Memo1.Lines.Add('begin');
  Memo1.Lines.Add(#9+'Result:=[esEnabled];');
  Memo1.Lines.Add('end;');
  Memo1.Lines.Add('');

  Memo1.Lines.Add('end.');
end;

procedure TExpertForm.PreviewSheetShow(Sender: TObject);
begin
  Preview;
end;

procedure TExpertForm.BitBtn4Click(Sender: TObject);
begin
  if Preview then
    Memo1.Lines.SaveToFile(EditUnit.Text)
  else
  begin
    ModalResult:=mrCancel;
    Close;
  end;

end;

end.
