unit ZeroWizardExpertUnit;

{
  Pan Ying,Zero Studio,2002.2.15
  All Right Reserved.

Attention:
    This software is provided 'as-is', without any express or
  implied warranty. In no event will the author be held liable
  for any damages arising from the use of this software.
    The origin of this software must not be misrepresented,
  you must not claim that you wrote the original software.
    This attention may not be removed or altered from any source
  distribution.

Feedback:
  E-Mail:  panying@sina.com
  HomePage:http://myzeroworld.yeah.net
}

interface

uses ExptIntf,Windows,Forms;

type
  TZeroWizrdExpert=class(TIExpert)
  public
    function GetStyle:TExpertStyle;override;
    function GetName:string;override;
    function GetAuthor:string;override;
    function GetComment:string;override;
    function GetPage:string;override;
    function GetGlyph:HICON;override;
    function GetState:TExpertState;override;
    function GetIDString:string;override;
    function GetMenuText:string;override;
    procedure Execute;override;
  end;

procedure Register;

implementation

{$R wizard.res}

uses
  UnitFrmExpert;

procedure Register;
begin
  RegisterLibraryExpert(TZeroWizrdExpert.Create);
end;

{ TZeroWizrdExpert }



procedure TZeroWizrdExpert.Execute;
begin
  try
    ExpertForm:=TExpertForm.Create(Application);
    if ExpertForm.ShowModal=idOK	 then
      ToolServices.OpenFile(ExpertForm.EditUnit.Text);
  finally
    ExpertForm.Free;
  end;
end;

function TZeroWizrdExpert.GetAuthor: string;
begin
  Result:='Pan Ying,Zero Studio';
end;

function TZeroWizrdExpert.GetComment: string;
begin
  Result:='Use this expert to create a wizard unit';
end;

function TZeroWizrdExpert.GetGlyph: HICON;
begin
  Result:=LoadIcon(HInstance,MakeIntResource('Icon1'));
end;

function TZeroWizrdExpert.GetIDString: string;
begin
  Result:='ZeroStudio.ZeroWizardExpert';
end;

function TZeroWizrdExpert.GetMenuText: string;
begin
  Result:='Zero Wizard Expert';
end;

function TZeroWizrdExpert.GetName: string;
begin
  Result:='Zero Wizard Expert';
end;

function TZeroWizrdExpert.GetPage: string;
begin
  Result:='New';
end;

function TZeroWizrdExpert.GetState: TExpertState;
begin
  Result:=[esEnabled];
end;

function TZeroWizrdExpert.GetStyle: TExpertStyle;
begin
  Result:=esProject;
end;

end.
